<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fmp="http://www.filemaker.com/fmpxmlresult" exclude-result-prefixes="fmp">
<xsl:output method="text" version="1.0" encoding="mac" indent="no" omit-xml-declaration="yes"/>

<!--	
	rtf-notes.xsl	(Notes de lecture, version 1.8 - novembre 2011 : modif police Times)
	===========
 	Transforme les donnees exportees de la table "Notes" en document rtf

	Parametres passes dans le dernier champ du 1er record uniquement :
	structure de la chaine : fldToPrint[prm1]motcleON[prm2]italicON[prm3]texte en en-tete[prm4]OnePerPage[prm5]

	Note : sans <xsl:strip-space elements="*"/> pour préserver tab et retour dans notes et citations

-->


<!-- valeurs constantes 	-->

<xsl:variable name="cr"> <xsl:text>\par &#13;</xsl:text> </xsl:variable>
<xsl:variable name="lf"> <xsl:text>&#10;</xsl:text> </xsl:variable>
<xsl:variable name="wineol"> <xsl:text>&#13;&#10;</xsl:text> </xsl:variable>
<xsl:variable name="FMeol"> <xsl:text>&#10;</xsl:text> </xsl:variable>

<xsl:variable name="openTagFM"> <xsl:text>xDEBUTx</xsl:text> </xsl:variable>
<xsl:variable name="closeTagFM"> <xsl:text>xFINx</xsl:text> </xsl:variable>
<xsl:variable name="openTagRTF"> <xsl:text>{\cs16\i </xsl:text> </xsl:variable>
<xsl:variable name="closeTagRTF"> <xsl:text>}</xsl:text> </xsl:variable>

<xsl:variable name="styleS4"> <xsl:text>\s4\ql \li0\ri0\sb220\sa80\keepn\widctlpar\outlinelevel3\rin0\lin0\itap0 \b\caps\f1\fs18\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 </xsl:text> </xsl:variable>
<xsl:variable name="styleBib"> <xsl:text>\s15\qj \li454\ri0\sb0\sa200\widctlpar\rin0\lin454\itap0 \f0\fs18\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 </xsl:text> </xsl:variable>
<xsl:variable name="styleMC"> <xsl:text>\s18\qj \li454\ri0\sb0\sa80\widctlpar\rin0\lin454\itap0 \f1\fs16\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 </xsl:text> </xsl:variable>
<xsl:variable name="styleCod"> <xsl:text>\s21\qr \li454\ri0\sb20\sa0\sl-160\slmult0\widctlpar\rin0\lin454\itap0 \f1\fs14\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 </xsl:text> </xsl:variable>
<xsl:variable name="styleNot"> <xsl:text>\s20\qj \li0\ri0\sb120\widctlpar\tx284\tx851\tx1418\tx1985\tx2552\tx3119\tx3686\tx4253\tx4820\tx5387\tx5954\rin0\lin0\itap0 \f0\fs20\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 \sbasedon0 </xsl:text> </xsl:variable>
<xsl:variable name="styleCit"> <xsl:text>\s19\qj \li0\ri0\sb80\widctlpar\tx284\tx851\tx1418\tx1985\tx2552\tx3119\tx3686\tx4253\tx4820\tx5387\tx5954\rin0\lin0\itap0 \f1\fs18\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 </xsl:text> </xsl:variable>
<xsl:variable name="styleInfos"> <xsl:text>\s17\qr \li0\ri0\sb640 \widctlpar\rin0\lin0\itap0 \f0\fs20\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 </xsl:text> </xsl:variable>
<xsl:variable name="styleNormal"> <xsl:text>\qj \li0\ri0\sb120 \widctlpar\rin0\lin0\itap0 \f0\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 </xsl:text> </xsl:variable>
<xsl:variable name="formS3"> <xsl:text>\s3\ql \li0\ri0\sb480\sa0\keepn\widctlpar\brdrb\brdrhair\brdrw5\brsp60 \outlinelevel2\rin0\lin0\itap0 \b\f1\fs22\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 </xsl:text> </xsl:variable>
<xsl:variable name="formS3nl"> <xsl:text>\s3\ql \li0\ri0\pagebb\sb0\sa0\keepn\widctlpar\brdrb\brdrhair\brdrw5\brsp60 \outlinelevel2\rin0\lin0\itap0 \b\f1\fs22\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 </xsl:text> </xsl:variable>

<!-- PARAMETRES : passe dans dernier champ du 1er record -->
<xsl:variable name="params"> <xsl:value-of select="fmp:FMPXMLRESULT/fmp:RESULTSET/fmp:ROW[1]/fmp:COL[last()]" /> </xsl:variable>
<xsl:param name="fldToPrint"><xsl:value-of select="substring-before($params,'[prm1]')" /></xsl:param>
<xsl:param name="motcleON"><xsl:value-of select="substring-before(substring-after($params,'[prm1]'), '[prm2]')" /></xsl:param>
<xsl:param name="italicON"><xsl:value-of select="substring-before(substring-after($params,'[prm2]'), '[prm3]')" /></xsl:param>
<xsl:param name="entete"><xsl:value-of select="substring-before(substring-after($params,'[prm3]'), '[prm4]')" /></xsl:param>
<xsl:param name="onePerPage"><xsl:value-of select="substring-before(substring-after($params,'[prm4]'), '[prm5]')" /></xsl:param>

<!-- style pour titre fiche : avec ou sans saut de page -->
<xsl:param name="styleS3">
	<xsl:choose>
		<xsl:when test="$onePerPage=1"> <xsl:value-of select="$formS3nl" />  </xsl:when>
		<xsl:otherwise> <xsl:value-of select="$formS3" /> </xsl:otherwise>
	</xsl:choose>
</xsl:param>


<!-- main template	-->
<xsl:template match="fmp:FMPXMLRESULT">

	<!-- en-tete rtf -->
	<xsl:call-template name="header" />

	<!-- fiches -->
	<xsl:choose>
		<xsl:when test='$fldToPrint=1'>
			<xsl:for-each select="fmp:RESULTSET/fmp:ROW">
				<xsl:call-template name="modele1" />
			</xsl:for-each>
		</xsl:when>
		<xsl:when test='$fldToPrint=2'>
			<xsl:for-each select="fmp:RESULTSET/fmp:ROW">
				<xsl:call-template name="modele2" />
			</xsl:for-each>
		</xsl:when>
		<xsl:when test='$fldToPrint=3'>
			<xsl:for-each select="fmp:RESULTSET/fmp:ROW">
				<xsl:call-template name="modele3" />
			</xsl:for-each>
		</xsl:when>
		<xsl:otherwise>
			<xsl:for-each select="fmp:RESULTSET/fmp:ROW">
				<xsl:call-template name="modele4" />
			</xsl:for-each>
		</xsl:otherwise>
	</xsl:choose>

	<!-- close rtf -->
	<xsl:text>}</xsl:text>
</xsl:template>

<!-- ======================== modeles selon champs a garder ====================  -->

<!-- 1 = fiche complete -->
<xsl:template name="modele1">
	<xsl:call-template name="fich-tit" />
	<xsl:call-template name="fich-mc" />
	<xsl:call-template name="RefBiblio">
		<xsl:with-param name="needForm" select ="$italicON" />
	</xsl:call-template>
	<xsl:call-template name="fich-not" />
	<xsl:text>\pard\plain </xsl:text> <xsl:value-of select="$styleS4" />
	<xsl:text>{Citations \par }</xsl:text>
	<xsl:call-template name="fich-cit" />
</xsl:template>

<!-- 2 = notes -->
<xsl:template name="modele2">
	<xsl:call-template name="fich-tit" />
	<xsl:call-template name="fich-mc" />
	<xsl:call-template name="RefBiblio">
		<xsl:with-param name="needForm" select ="$italicON" />
	</xsl:call-template>
	<xsl:call-template name="fich-not" />
</xsl:template>

<!-- 3 = extraits -->
<xsl:template name="modele3">
	<xsl:call-template name="fich-tit" />
	<xsl:call-template name="fich-mc" />
	<xsl:call-template name="RefBiblio">
		<xsl:with-param name="needForm" select ="$italicON" />
	</xsl:call-template>
	<xsl:call-template name="fich-cit" />
</xsl:template>

<!-- 4 = MC uniquement -->
<xsl:template name="modele4">
	<xsl:call-template name="fich-tit" />
	<xsl:call-template name="fich-mc" />
</xsl:template>

<!-- ======================== composants ====================  -->

<!-- Titre et code de la fiche -->
<xsl:template name="fich-tit">
	<xsl:text>\pard\plain </xsl:text>
	<xsl:value-of select="$styleS3" />
	<xsl:text>{</xsl:text>
	<xsl:value-of select="normalize-space(fmp:COL[1])" />
	<xsl:text> / </xsl:text>
	<xsl:value-of select="normalize-space(fmp:COL[2])" />
	<xsl:text>\par }</xsl:text>
	<xsl:text>\pard\plain </xsl:text> <xsl:value-of select="$styleCod" />
	<xsl:text>{</xsl:text>
		<xsl:value-of select="fmp:COL[7]" />
	<xsl:text>\par }</xsl:text>
</xsl:template>

<!-- mots cles -->
<xsl:template name="fich-mc">
	<xsl:text>\pard\plain </xsl:text> <xsl:value-of select="$styleMC" />
	<xsl:text>{</xsl:text>
		<xsl:value-of select="normalize-space(fmp:COL[5])" />
	<xsl:text>\par }</xsl:text>
</xsl:template>

<!-- notes -->
<xsl:template name="fich-not">
	<xsl:text>\pard\plain </xsl:text> <xsl:value-of select="$styleNot" />
	<xsl:text>{</xsl:text>
	<xsl:call-template name="replaceString">
		<xsl:with-param name="str" select ="fmp:COL[3]" />
		<xsl:with-param name="from" select ="$FMeol" />
		<xsl:with-param name="to" select ="$cr" />
	</xsl:call-template>
	<xsl:text>\par }</xsl:text>
</xsl:template>

<!-- extraits -->
<xsl:template name="fich-cit">
	<xsl:text>\pard\plain </xsl:text> <xsl:value-of select="$styleCit" />
	<xsl:text>{</xsl:text>
	<xsl:call-template name="replaceString">
		<xsl:with-param name="str" select ="fmp:COL[4]" />
		<xsl:with-param name="from" select ="$FMeol" />
		<xsl:with-param name="to" select ="$cr" />
	</xsl:call-template>
	<xsl:text>\par }</xsl:text>
</xsl:template>

<!-- ref bib  -->
<xsl:template name="RefBiblio">
<xsl:param name="needForm" />
	<xsl:text>\pard\plain </xsl:text> <xsl:value-of select="$styleBib" />
	<xsl:text>{</xsl:text>
	<xsl:choose>
		<xsl:when test='$needForm=1'>
			<xsl:call-template name="replaceOpenAndCloseTags">
				<xsl:with-param name="str" select="normalize-space(fmp:COL[6])" />
				<xsl:with-param name="from" select ="$openTagFM" />
				<xsl:with-param name="to" select ="$openTagRTF" />
				<xsl:with-param name="from2" select ="$closeTagFM" />
				<xsl:with-param name="to2" select ="$closeTagRTF" />
			</xsl:call-template>
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="replaceOpenAndCloseTags">
				<xsl:with-param name="str" select="normalize-space(fmp:COL[6])" />
				<xsl:with-param name="from" select ="$openTagFM" />
				<xsl:with-param name="to" select ="''" />
				<xsl:with-param name="from2" select ="$closeTagFM" />
				<xsl:with-param name="to2" select ="''" />
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
	<xsl:text>\par }</xsl:text>
</xsl:template>

<!-- en-tete rtf -->
<xsl:template name="header">
	<xsl:text>{\rtf1\mac\ansicpg10000\uc1 \deff0\stshfdbch0\stshfloch0\stshfhich0\stshfbi0\deflang1036\deflangfe1036
{\upr{\fonttbl
{\f0\fnil\fcharset256\fprq2{\*\panose 00020206030504050203}Times New Roman{\*\falt Times};}
{\f1\fnil\fcharset256\fprq2{\*\panose 00020b06040202020202}Arial;}
{\f4\fnil\fcharset256\fprq2{\*\panose 00020005000000000000}Times;}}
{\*\ud{\fonttbl
{\f0\fnil\fcharset256\fprq2{\*\panose 00020206030504050203}Times New Roman{\*\falt Times};}
{\f1\fnil\fcharset256\fprq2{\*\panose 00020b06040202020202}Arial;}
{\f4\fnil\fcharset256\fprq2{\*\panose 00020005000000000000}Times;}}
}}
{\colortbl;\red0\green0\blue0;\red0\green0\blue255;\red0\green255\blue255;\red0\green255\blue0;\red255\green0\blue255;
\red255\green0\blue0;\red255\green255\blue0;\red255\green255\blue255;\red0\green0\blue128;\red0\green128\blue128;\red0\green128\blue0;\red128\green0\blue128;\red128\green0\blue0;\red128\green128\blue0;\red128\green128\blue128;\red192\green192\blue192;}
{\stylesheet
{</xsl:text> <xsl:value-of select="$styleNormal"/> <xsl:text>\snext0 Normal;}
{\s1\qc \li0\ri0480\sb0\sa640\keepn\widctlpar\rin0\lin0\itap0 \b\f0\fs32\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 \sbasedon0 \snext0 heading 1;}
{</xsl:text><xsl:value-of select="$styleS3"/> <xsl:text>\sbasedon0 \snext0 heading 3;}
{</xsl:text> <xsl:value-of select="$styleS4"/> <xsl:text>\sbasedon0 \snext0 heading 4;}
{\*\cs10 \additive Default Paragraph Font;}
{</xsl:text> <xsl:value-of select="$styleBib"/> <xsl:text>\sbasedon0 \snext15 NDLbiblio;}
{\*\cs16 \additive \i \sbasedon10 car-italiq;}
{</xsl:text> <xsl:value-of select="$styleInfos"/> <xsl:text>\snext17 NDLinfos;}
{</xsl:text> <xsl:value-of select="$styleMC"/> <xsl:text>\sbasedon0 \snext18 NDLcles;}
{</xsl:text> <xsl:value-of select="$styleCit"/> <xsl:text>\sbasedon0 \snext19 NDLcit;}
{</xsl:text> <xsl:value-of select="$styleNot"/> <xsl:text>\snext20 NDLnot;}
{</xsl:text> <xsl:value-of select="$styleCod"/> <xsl:text>\sbasedon18 \snext21 NDLcode;}
{\s22\qj \li0\ri0\sl-200\slmult0\widctlpar\tqr\tx9072\faauto\rin0\lin0\itap0 \i\f0\fs20\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 \sbasedon0 \snext22 header;}
{\s23\qj \li0\ri0\sl-200\slmult0\widctlpar\tqr\tx9072\faauto\rin0\lin0\itap0 \f0\fs20\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 \sbasedon0 \snext23 footer;}
{\*\cs24 \additive \sbasedon10 page number;}
}
{\info
{\title Fiches de lecture}
{\subject NDL - export du fichier Notes}
{\author Logiciel Notes de lecture}
{\operator Logiciel Notes de lecture}
{\*\company Universit\'8e Lyon 2, d\'8epartement des Lettres}
}
\paperw11906\paperh16838\margl1418\margr1418\margt1247\margb1134 
\deftab708\ftnbj\aenddoc\hyphhotz425
\noxlattoyen\expshrtn\noultrlspc\dntblnsbdb\nospaceforul
\hyphcaps0\hyphauto0\formshade
\horzdoc\dgmargin\dghspace180\dgvspace180\dghorigin1701\dgvorigin1984\dghshow0\dgvshow0
\jexpand\viewkind1\viewscale100\pgbrdrhead\pgbrdrfoot\splytwnine\ftnlytwnine\htmautsp\nolnhtadjtbl\useltbaln\alntblind\lytcalctblwd\lyttblrtgr\lnbrkrule\nobrkwrptbl \fet0\sectd 
\linex0\headery709\footery709\colsx708\endnhere\sectdefaultcl\sftnbj 

{\header \pard\plain \s22\qj \li0\ri0\sl-200\slmult0\widctlpar\tqr\tx9072\faauto\rin0\lin0\itap0 \i\f0\fs20\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 
{</xsl:text> <xsl:value-of select="$entete" /> <xsl:text>\tab }{\field{\*\fldinst {PAGE }}{\fldrslt {\lang1024\langfe1024\noproof}}}{\par }
}
{\footer \pard\plain \s23\qj \li0\ri0\sl-200\slmult0\widctlpar\tqr\tx9072\faauto\rin0\lin0\itap0 \f0\fs20\lang1036\langfe1036\cgrid\langnp1036\langfenp1036 {\par }}
</xsl:text>
</xsl:template>



<!-- ****************** UTILITAIRES ****************** -->

<!-- replaceOpenAndCloseTags $str, $from, $to, $from2, $to2
		rech/remplacement d'un couple de chaine dans un paragraphe :		pour traitement des balises entourant passages a formater
-->
<xsl:template name="replaceOpenAndCloseTags">
	<xsl:param name="str" />
	<xsl:param name="from" />
	<xsl:param name="to" />
	<xsl:param name="from2" />
	<xsl:param name="to2" />
	<xsl:choose>
		<xsl:when test="contains($str,$from)">
			<xsl:variable name="tmp">
				<xsl:call-template name="replaceString">
					<xsl:with-param name="str" select ="$str" />
					<xsl:with-param name="from" select ="$from2" />
					<xsl:with-param name="to" select ="$to2" />
				</xsl:call-template>
			</xsl:variable>
			<xsl:value-of select="substring-before($tmp,$from)" />
			<xsl:value-of select="$to" />
			<xsl:call-template name="replaceString">
				<xsl:with-param name="str" select ="substring-after($tmp,$from)" />
				<xsl:with-param name="from" select ="$from" />
				<xsl:with-param name="to" select ="$to" />
			</xsl:call-template>
		 </xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$str" />
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- 	replaceString $str, $from, $to
		rech/remplacement simple dans une chaine (recursif)
-->
<xsl:template name="replaceString">
	<xsl:param name="str" />
	<xsl:param name="from" />
	<xsl:param name="to" />
	<xsl:choose>
		<xsl:when test="contains($str,$from)">
			<xsl:value-of select="substring-before($str,$from)" />
			<xsl:value-of select="$to" />
			<xsl:call-template name="replaceString">
				<xsl:with-param name="str" select ="substring-after($str,$from)" />
				<xsl:with-param name="from" select ="$from" />
				<xsl:with-param name="to" select ="$to" />
			</xsl:call-template>
		 </xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$str" />
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet>